#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <stdint.h>


uint32_t *data;
int datalen;

void loadinput(char *fname)
{
	FILE *tfile;
	int flen;

	tfile = fopen(fname, "rb");
	if(!tfile)
	{
		perror("Can't open input file");
		exit(10);
	}
	if(!fseek(tfile, 0, SEEK_END))
	{
		datalen = ftell(tfile) / 8;
		flen = datalen * 8;
		if(flen > 0)
		{
			if(!fseek(tfile, 0, SEEK_SET))
			{
				data = (uint32_t *)malloc(flen);
				if(!data)
				{
					printf("Out of memory!\n");
					exit(10);
				}
				if(fread(data, flen, 1, tfile) != 1)
				{
					perror("Read error on input file");
					exit(10);
				}
				fclose(tfile);
				return;
			}
		}
	}
	fclose(tfile);
	perror("Seek error on input file");
	exit(10);
}

int cmpoutput(uint32_t *a, uint32_t *b)
{
	if(*a < *b) return(-1);
	if(*a > *b) return(1);
	if(a[1] < b[1]) return(-1);
	return(1);
}

void do_sort(char *infilename, char *outfilename)
{
	loadinput(infilename);

	FILE *outfile = fopen(outfilename, "wb");
	if(!outfile)
	{
		perror("Can't open output file");
		exit(10);
	}

	qsort(data, datalen, 8,
		(int (*)(const void *,const void *))cmpoutput);

	fwrite(data, 8, datalen, outfile);
	fclose(outfile);
}

int main(int argc, char **argv)
{
	char fnamebuf[2][32];

	printf("[result_sort]\n");

	if(argc == 3) do_sort(argv[1], argv[2]);
	else if(argc == 2)
	{
		sprintf(fnamebuf[0], "n_%02d.ures", atoi(argv[1]));
		sprintf(fnamebuf[1], "qqqn%02d.q", atoi(argv[1]));
		do_sort(fnamebuf[0], fnamebuf[1]);
	}
	else
	{
		printf("Syntax: result_sort N | (input_file output_file)\n");
	}

	return(0);
}
