#ifndef RULE_CANAL2_H
#define RULE_CANAL2_H

#include "basic_state.h"
#include <cmath>

static const double canal2_alpha = 7.0;

struct rule_canal2
{
	typedef basic_state state_t;
	typedef knode_basic<rule_canal2> knode_t;
	typedef knet_basic<rule_canal2>::type knet_t;

	static void evaluatenode(knode_t &k, int i, state_t &s1, state_t &s2);
	static void evaluate(knet_t &net, state_t &s1, state_t &s2);
	static bool random_bool(int l)
	{
		return gsl_rng_uniform_pos(rng) < 1./(1. + exp(canal2_alpha/double(1 << l)));
	}
	static void randomize(knet_t &net, bool dummy = 0);
	inline static void clampNodes(knet_t &net)
	{
	}

	static void fixInput(knode_t &k, int index, int value);

	inline void init(int inputs)
	{
		_rule.resize(inputs << 1, 0);
	}
	inline bool isBad() const
	{
		return _rule.empty();
	}
	inline void makeBad()
	{
		_rule.clear();
	}
	inline void print(std::ostream &out)
	{
		if(_rule.size() == 1)
			out << "  " << int(_rule[0]);
		else
		{
			for(unsigned int i = 0; i + 1 < _rule.size(); i += 2)
				out << "  " << int(_rule[i]) << "/" << int(_rule[i+1]);
		}
	}

	std::vector<char> _rule;
};

#endif
