/**
 * Filename     : creation.h
 * Description  : Classes describing creation of molecules
 * Author(s)    : Henrik Jonsson (henrik@thep.lu.se)
 *              : Pontus Melke
 * Created      : December 2003
 * Revision     : $Id: creation.h,v 1.5 2006/03/18 12:23:08 henrik Exp $
 */
#ifndef CREATION_H
#define CREATION_H

#include "baseReaction.h"

//!CreationZero applies a constant creation 
class CreationZero : public BaseReaction {
  
 public:
  
  CreationZero(std::vector<double> &paraValue, 
	       std::vector< std::vector<size_t> > &indValue );
  
  void derivs(Compartment &compartment,size_t species,
	      std::vector< std::vector<double> > &y,
	      std::vector< std::vector<double> > &dydt );
};

//!CreationOne assumes a creation proportional to a species concentration
class CreationOne : public BaseReaction {
  
 public:
  
  CreationOne(std::vector<double> &paraValue, 
	      std::vector< std::vector<size_t> > &indValue );
  
  void derivs(Compartment &compartment,size_t species,
	      std::vector< std::vector<double> > &y,
	      std::vector< std::vector<double> > &dydt );
};


#endif


