/**
 * Filename     : grn.h
 * Description  : Classes describing gene regulatory network updates
 * Author(s)    : Henrik Jonsson (henrik@thep.lu.se)
 * Created      : October 2003
 * Revision     : $Id: grn.h,v 1.3 2006/03/18 00:05:14 henrik Exp $
 */
#ifndef GRN_H
#define GRN_H

#include"baseReaction.h"
#include<cmath>

//!The class grn use a neural network inspired mathematics for gene regulation
class Grn : public BaseReaction {
  
 public:
  
  Grn(std::vector<double> &paraValue, 
      std::vector< std::vector<size_t> > &indValue );
  
  //virtual Grn::Grn();

  void derivs(Compartment &compartment,size_t specie,
	      std::vector< std::vector<double> > &y,
	      std::vector< std::vector<double> > &dydt );
  inline double sigmoid( double value );
};
inline double Grn::sigmoid(double x) { return 0.5*(1 + x/sqrt(1+x*x) );}


#endif
