/**
 * Filename     : massAction.h
 * Description  : Classes describing mass action reactions
 * Author(s)    : Henrik Jonsson (henrik@thep.lu.se)
 * Created      : November 2003
 * Revision     : $Id: massAction.h,v 1.3 2006/03/18 00:05:14 henrik Exp $
 */
#ifndef MASSACTION_H
#define MASSACTION_H

#include "baseReaction.h"

//!A one way mass action reaction with enzyme contribution
/*! The reactant indeces are in level zero, products in level one, and enzymes
  in level two in variableIndex. One parameter is needed.*/
class MassActionEnzymatic : public BaseReaction {
  
 public:
  
  MassActionEnzymatic(std::vector<double> &paraValue, 
		      std::vector< std::vector<size_t> > &indValue );
  
  void derivs(Compartment &compartment,size_t varIndex,
	      std::vector< std::vector<double> > &y,
	      std::vector< std::vector<double> > &dydt );
};

#endif

