/**
 * Filename     : simulator.cc
 * Description  : Normal lattice simulation assuming spherical cells
 * Author(s)    : Henrik Jonsson (henrik@thep.lu.se)
 * Created      : February 2004
 * Revision     : $Id: simulator.cc,v 1.4 2006/02/17 14:07:21 pontus Exp $
 */
#include<vector>
#include<iostream>
#include"organism.h"
#include"rk5Adaptive.h"

int main(int argc,char *argv[]) {
  
  //Input handeling
  //////////////////////////////////////////////////////////////////////
  if( argc != 4 ) {
    std::cerr << "usage: " << argv[0] << " modelFile initFile "
	      << "simulatorParaFile\n";
    exit(-1);
  }
  std::string modelFile=argv[1];
  std::string initFile=argv[2];
  std::string simPara=argv[3];
  
  //Define the organism (model) and simulator
  //////////////////////////////////////////////////////////////////////
  Organism O(modelFile,initFile);
  Rk5Adaptive S(&O,simPara);
  //O.printParameter();
  
  //Simulate with updates of the neighborhood
  //////////////////////////////////////////////////////////////////////
  std::cerr << "Start simulation.\n";
  S.simulate();
}
