/**
 * Filename     : transport.h
 * Description  : Classes describing transports of molecules
 * Author(s)    : Henrik Jonsson (henrik@thep.lu.se)
 * Created      : October 2003
 * Revision     : $Id: transport.h,v 1.10 2006/03/18 00:05:14 henrik Exp $
 */
#ifndef TRANSPORT_H
#define TRANSPORT_H

#include"baseReaction.h"
#include<cmath>

//!The class DiffusionSimple is the simplest diffusion update
class DiffusionSimple : public BaseReaction {
  
 public:
  
  DiffusionSimple(std::vector<double> &paraValue, 
		  std::vector< std::vector<size_t> > &indValue );
  
  void derivs(Compartment &compartment,size_t species,
	      std::vector< std::vector<double> > &y,
	      std::vector< std::vector<double> > &dydt );
};


#endif
